// -------------------------------------------------------------
//
// Module: CASCADE_D130
//
// Generated by MATLAB(R) 7.2 and the Filter Design HDL Coder 1.4.
//
// Generated on: 2006-09-19 12:54:48
//
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// TargetLanguage: Verilog
// Name: CASCADE_D130
// TargetDirectory: c:\data
// FIRAdderStyle: tree
// CoeffMultipliers: csd
// SerialPartition: -1
// AddPipelineRegisters: On
//
// Filter Settings:
//
// Discrete-Time FIR Filter (real)
// -------------------------------
// Filter Structure  : Cascade
// Number of Stages  : 2
// Stable            : Yes
// Linear Phase      : Yes (Type 1)
//
// Implementation Cost
// Number of Multipliers : 0
// Number of Adders      : 32
// Number of States      : 32
// MultPerInputSample    : 0
// AddPerInputSample     : 16.1692
// -------------------------------------------------------------

`timescale 1 ns / 1 ns

module CASCADE_D130 
               (
                clk,
                clk_enable,
                reset,
                filter_in,
                filter_out,
                ce_out
                );

  input   clk; 
  input   clk_enable; 
  input   reset; 
  input   signed [15:0] filter_in; //sfix16
  output  signed [23:0] filter_out; //sfix24_En11
  output  ce_out; 

////////////////////////////////////////////////////////////////
//Module Architecture: CASCADE_D130
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  // Signals
  wire signed [15:0] filter_in_stage1; // sfix16
  wire signed [17:0] filter_out_stage1; // sfix18_E35
  wire clk_enable_stage1; // boolean
  wire ce_out_stage1; // boolean
  wire signed [17:0] filter_in_stage2; // sfix18_En15
  wire signed [23:0] filter_out_stage2; // sfix24_En11
  wire clk_enable_stage2; // boolean
  wire ce_out_stage2; // boolean
  wire signed [17:0] filter_in_stage2_tmp; // sfix18_En15
  CASCADE_D130_stage1 u_CASCADE_D130_stage1
    (
    .clk(clk),
    .clk_enable_stage1(clk_enable_stage1),
    .reset(reset),
    .filter_in_stage1(filter_in_stage1),
    .filter_out_stage1(filter_out_stage1),
    .ce_out_stage1(ce_out_stage1)
    );

  CASCADE_D130_stage2 u_CASCADE_D130_stage2
    (
    .clk(clk),
    .clk_enable_stage2(clk_enable_stage2),
    .reset(reset),
    .filter_in_stage2(filter_in_stage2),
    .filter_out_stage2(filter_out_stage2),
    .ce_out_stage2(ce_out_stage2)
    );


  // Block Statements
  assign filter_in_stage1 = filter_in;
  assign filter_in_stage2_tmp = (filter_out_stage1[17] == 1'b0 & filter_out_stage1[16:0] != 17'b00000000000000000) ? 18'b011111111111111111 : 
      (filter_out_stage1[17] == 1'b1 && filter_out_stage1[16:0] != 17'b11111111111111111) ? 18'b100000000000000000 : $signed({filter_out_stage1[17], 17'b00000000000000000});

  assign filter_in_stage2 = filter_in_stage2_tmp;
  assign clk_enable_stage1 = clk_enable;
  assign clk_enable_stage2 = ce_out_stage1;
  assign ce_out = ce_out_stage2;
  // Assignment Statements
  assign filter_out = filter_out_stage2;
endmodule  // CASCADE_D130
