// -------------------------------------------------------------
//
// Module: CIC_R100_M1_N5_CFIR
//
// Generated by MATLAB(R) 7.2 and the Filter Design HDL Coder 1.4.
//
// Generated on: 2006-09-12 11:58:09
//
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// TargetLanguage: Verilog
// Name: CIC_R100_M1_N5_CFIR
// TargetDirectory: c:\data
// FIRAdderStyle: tree
// CoeffMultipliers: csd
// SerialPartition: -1
// AddPipelineRegisters: On
//
// Filter Settings:
//
// Discrete-Time FIR Filter (real)
// -------------------------------
// Filter Structure  : Cascade
// Number of Stages  : 2
// Stable            : Yes
// Linear Phase      : Yes (Type 2)
//
// Implementation Cost
// Number of Multipliers : 39
// Number of Adders      : 48
// Number of States      : 48
// MultPerInputSample    : 0.195
// AddPerInputSample     : 5.24
// -------------------------------------------------------------

`timescale 1 ns / 1 ns

module CIC_R100_M1_N5_CFIR 
               (
                clk,
                clk_enable,
                reset,
                filter_in,
                filter_out,
                ce_out
                );

  input   clk; 
  input   clk_enable; 
  input   reset; 
  input   signed [15:0] filter_in; //sfix16
  output  signed [38:0] filter_out; //sfix39_En33
  output  ce_out; 

////////////////////////////////////////////////////////////////
//Module Architecture: CIC_R100_M1_N5_CFIR
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  // Signals
  wire signed [15:0] filter_in_stage1; // sfix16
  wire signed [19:0] filter_out_stage1; // sfix20_E30
  wire clk_enable_stage1; // boolean
  wire ce_out_stage1; // boolean
  wire signed [19:0] filter_in_stage2; // sfix20_En15
  wire signed [38:0] filter_out_stage2; // sfix39_En33
  wire clk_enable_stage2; // boolean
  wire ce_out_stage2; // boolean
  wire signed [19:0] filter_in_stage2_tmp; // sfix20_En15
  CIC_R100_M1_N5_CFIR_stage1 u_CIC_R100_M1_N5_CFIR_stage1
    (
    .clk(clk),
    .clk_enable_stage1(clk_enable_stage1),
    .reset(reset),
    .filter_in_stage1(filter_in_stage1),
    .filter_out_stage1(filter_out_stage1),
    .ce_out_stage1(ce_out_stage1)
    );

  CIC_R100_M1_N5_CFIR_stage2 u_CIC_R100_M1_N5_CFIR_stage2
    (
    .clk(clk),
    .clk_enable_stage2(clk_enable_stage2),
    .reset(reset),
    .filter_in_stage2(filter_in_stage2),
    .filter_out_stage2(filter_out_stage2),
    .ce_out_stage2(ce_out_stage2)
    );


  // Block Statements
  assign filter_in_stage1 = filter_in;
  assign filter_in_stage2_tmp = (filter_out_stage1[19] == 1'b0 & filter_out_stage1[18:0] != 19'b0000000000000000000) ? 20'b01111111111111111111 : 
      (filter_out_stage1[19] == 1'b1 && filter_out_stage1[18:0] != 19'b1111111111111111111) ? 20'b10000000000000000000 : $signed({filter_out_stage1[19], 19'b0000000000000000000});

  assign filter_in_stage2 = filter_in_stage2_tmp;
  assign clk_enable_stage1 = clk_enable;
  assign clk_enable_stage2 = ce_out_stage1;
  assign ce_out = ce_out_stage2;
  // Assignment Statements
  assign filter_out = filter_out_stage2;
endmodule  // CIC_R100_M1_N5_CFIR
