// -------------------------------------------------------------
//
// Module: CIC_R256_M1_N7
//
// Generated by MATLAB(R) 7.2 and the Filter Design HDL Coder 1.4.
//
// Generated on: 2006-09-15 19:12:32
//
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// TargetLanguage: Verilog
// Name: CIC_R256_M1_N7
// TargetDirectory: c:\data
// FIRAdderStyle: tree
// CoeffMultipliers: csd
// SerialPartition: -1
// AddPipelineRegisters: On
// CastBeforeSum: On
//
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure        : Cascaded Integrator-Comb Decimator
// Decimation Factor       : 256
// Differential Delay      : 1
// Number of Sections      : 7
// Stable                  : Yes
// Linear Phase            : Yes (Type 2)
//
// Input                   : s16,0
// Output                  : s18,-54
// Filter Internals        : Minimum Word Lengths
//   Integrator Section 1  : s61,-11
//   Integrator Section 2  : s61,-11
//   Integrator Section 3  : s61,-11
//   Integrator Section 4  : s49,-23
//   Integrator Section 5  : s42,-30
//   Integrator Section 6  : s36,-36
//   Integrator Section 7  : s29,-43
//   Comb Section 1        : s26,-46
//   Comb Section 2        : s25,-47
//   Comb Section 3        : s24,-48
//   Comb Section 4        : s23,-49
//   Comb Section 5        : s23,-49
//   Comb Section 6        : s22,-50
//   Comb Section 7        : s21,-51
//
// Implementation Cost
// Number of Multipliers : 0
// Number of Adders      : 14
// Number of States      : 14
// MultPerInputSample    : 0
// AddPerInputSample     : 7.0273
// -------------------------------------------------------------

`timescale 1 ns / 1 ns

module CIC_R256_M1_N7 
               (
                clk,
                clk_enable,
                reset,
                filter_in,
                filter_out,
                ce_out
                );

  input   clk; 
  input   clk_enable; 
  input   reset; 
  input   signed [15:0] filter_in; //sfix16
  output  signed [17:0] filter_out; //sfix18_E54
  output  ce_out; 

////////////////////////////////////////////////////////////////
//Module Architecture: CIC_R256_M1_N7
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  // Signals
  reg  [7:0] cur_count; // ufix8
  wire phase_1; // boolean
  wire ce_delayline; // boolean
  reg  int_delay_pipe [0:5] ; // boolean
  wire ce_gated; // boolean
  reg  ce_out_reg; // boolean
  //   
  reg  signed [15:0] input_register; // sfix16
  //   -- Section 1 Signals 
  wire signed [15:0] section_in1; // sfix16
  wire signed [60:0] section_cast1; // sfix61_E11
  wire signed [60:0] sum1; // sfix61_E11
  reg  signed [60:0] section_out1; // sfix61_E11
  wire signed [60:0] add_cast; // sfix61_E11
  wire signed [60:0] add_cast_1; // sfix61_E11
  wire signed [61:0] add_temp; // sfix62_E11
  //   -- Section 2 Signals 
  wire signed [60:0] section_in2; // sfix61_E11
  wire signed [60:0] sum2; // sfix61_E11
  reg  signed [60:0] section_out2; // sfix61_E11
  wire signed [60:0] add_cast_2; // sfix61_E11
  wire signed [60:0] add_cast_3; // sfix61_E11
  wire signed [61:0] add_temp_1; // sfix62_E11
  //   -- Section 3 Signals 
  wire signed [60:0] section_in3; // sfix61_E11
  wire signed [60:0] sum3; // sfix61_E11
  reg  signed [60:0] section_out3; // sfix61_E11
  wire signed [60:0] add_cast_4; // sfix61_E11
  wire signed [60:0] add_cast_5; // sfix61_E11
  wire signed [61:0] add_temp_2; // sfix62_E11
  //   -- Section 4 Signals 
  wire signed [60:0] section_in4; // sfix61_E11
  wire signed [48:0] section_cast4; // sfix49_E23
  wire signed [48:0] sum4; // sfix49_E23
  reg  signed [48:0] section_out4; // sfix49_E23
  wire signed [48:0] add_cast_6; // sfix49_E23
  wire signed [48:0] add_cast_7; // sfix49_E23
  wire signed [49:0] add_temp_3; // sfix50_E23
  //   -- Section 5 Signals 
  wire signed [48:0] section_in5; // sfix49_E23
  wire signed [41:0] section_cast5; // sfix42_E30
  wire signed [41:0] sum5; // sfix42_E30
  reg  signed [41:0] section_out5; // sfix42_E30
  wire signed [41:0] add_cast_8; // sfix42_E30
  wire signed [41:0] add_cast_9; // sfix42_E30
  wire signed [42:0] add_temp_4; // sfix43_E30
  //   -- Section 6 Signals 
  wire signed [41:0] section_in6; // sfix42_E30
  wire signed [35:0] section_cast6; // sfix36_E36
  wire signed [35:0] sum6; // sfix36_E36
  reg  signed [35:0] section_out6; // sfix36_E36
  wire signed [35:0] add_cast_10; // sfix36_E36
  wire signed [35:0] add_cast_11; // sfix36_E36
  wire signed [36:0] add_temp_5; // sfix37_E36
  //   -- Section 7 Signals 
  wire signed [35:0] section_in7; // sfix36_E36
  wire signed [28:0] section_cast7; // sfix29_E43
  wire signed [28:0] sum7; // sfix29_E43
  reg  signed [28:0] section_out7; // sfix29_E43
  wire signed [28:0] add_cast_12; // sfix29_E43
  wire signed [28:0] add_cast_13; // sfix29_E43
  wire signed [29:0] add_temp_6; // sfix30_E43
  //   -- Section 8 Signals 
  wire signed [28:0] section_in8; // sfix29_E43
  wire signed [25:0] section_cast8; // sfix26_E46
  reg  signed [25:0] diff1; // sfix26_E46
  wire signed [25:0] section_out8; // sfix26_E46
  wire signed [25:0] sub_cast; // sfix26_E46
  wire signed [25:0] sub_cast_1; // sfix26_E46
  wire signed [26:0] sub_temp; // sfix27_E46
  reg  signed [25:0] cic_pipeline8; // sfix26_E46
  //   -- Section 9 Signals 
  wire signed [25:0] section_in9; // sfix26_E46
  wire signed [24:0] section_cast9; // sfix25_E47
  reg  signed [24:0] diff2; // sfix25_E47
  wire signed [24:0] section_out9; // sfix25_E47
  wire signed [24:0] sub_cast_2; // sfix25_E47
  wire signed [24:0] sub_cast_3; // sfix25_E47
  wire signed [25:0] sub_temp_1; // sfix26_E47
  reg  signed [24:0] cic_pipeline9; // sfix25_E47
  //   -- Section 10 Signals 
  wire signed [24:0] section_in10; // sfix25_E47
  wire signed [23:0] section_cast10; // sfix24_E48
  reg  signed [23:0] diff3; // sfix24_E48
  wire signed [23:0] section_out10; // sfix24_E48
  wire signed [23:0] sub_cast_4; // sfix24_E48
  wire signed [23:0] sub_cast_5; // sfix24_E48
  wire signed [24:0] sub_temp_2; // sfix25_E48
  reg  signed [23:0] cic_pipeline10; // sfix24_E48
  //   -- Section 11 Signals 
  wire signed [23:0] section_in11; // sfix24_E48
  wire signed [22:0] section_cast11; // sfix23_E49
  reg  signed [22:0] diff4; // sfix23_E49
  wire signed [22:0] section_out11; // sfix23_E49
  wire signed [22:0] sub_cast_6; // sfix23_E49
  wire signed [22:0] sub_cast_7; // sfix23_E49
  wire signed [23:0] sub_temp_3; // sfix24_E49
  reg  signed [22:0] cic_pipeline11; // sfix23_E49
  //   -- Section 12 Signals 
  wire signed [22:0] section_in12; // sfix23_E49
  reg  signed [22:0] diff5; // sfix23_E49
  wire signed [22:0] section_out12; // sfix23_E49
  wire signed [22:0] sub_cast_8; // sfix23_E49
  wire signed [22:0] sub_cast_9; // sfix23_E49
  wire signed [23:0] sub_temp_4; // sfix24_E49
  reg  signed [22:0] cic_pipeline12; // sfix23_E49
  //   -- Section 13 Signals 
  wire signed [22:0] section_in13; // sfix23_E49
  wire signed [21:0] section_cast13; // sfix22_E50
  reg  signed [21:0] diff6; // sfix22_E50
  wire signed [21:0] section_out13; // sfix22_E50
  wire signed [21:0] sub_cast_10; // sfix22_E50
  wire signed [21:0] sub_cast_11; // sfix22_E50
  wire signed [22:0] sub_temp_5; // sfix23_E50
  reg  signed [21:0] cic_pipeline13; // sfix22_E50
  //   -- Section 14 Signals 
  wire signed [21:0] section_in14; // sfix22_E50
  wire signed [20:0] section_cast14; // sfix21_E51
  reg  signed [20:0] diff7; // sfix21_E51
  wire signed [20:0] section_out14; // sfix21_E51
  wire signed [20:0] sub_cast_12; // sfix21_E51
  wire signed [20:0] sub_cast_13; // sfix21_E51
  wire signed [21:0] sub_temp_6; // sfix22_E51
  wire signed [17:0] output_typeconvert; // sfix18_E54
  //   
  reg  signed [17:0] output_register; // sfix18_E54

  // Block Statements
  //   ------------------ CE Output Generation ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_output
      if (reset == 1'b1) begin
        cur_count <= 8'b00000000;
      end
      else begin
        if (clk_enable == 1'b1) begin
          if (cur_count == 8'b11111111) begin
            cur_count <= 8'b00000000;
          end
          else begin
            cur_count <= cur_count + 1;
          end
        end
      end
    end // ce_output

  assign  phase_1 = (cur_count == 8'b00000001 && clk_enable == 1'b1)? 1 : 0;

  always @( posedge clk or posedge reset)
    begin: ce_delay
      if (reset == 1'b1) begin
        int_delay_pipe[0] <= 1'b0;
        int_delay_pipe[1] <= 1'b0;
        int_delay_pipe[2] <= 1'b0;
        int_delay_pipe[3] <= 1'b0;
        int_delay_pipe[4] <= 1'b0;
        int_delay_pipe[5] <= 1'b0;
      end
      else begin
        if (phase_1 == 1'b1) begin
        int_delay_pipe[0] <= clk_enable;
        int_delay_pipe[1] <= int_delay_pipe[0];
        int_delay_pipe[2] <= int_delay_pipe[1];
        int_delay_pipe[3] <= int_delay_pipe[2];
        int_delay_pipe[4] <= int_delay_pipe[3];
        int_delay_pipe[5] <= int_delay_pipe[4];
        end
      end
    end // ce_delay

    assign ce_delayline = int_delay_pipe[5];
  assign ce_gated =  ce_delayline & phase_1;

  //   ------------------ CE Output Register ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_output_register
      if (reset == 1'b1) begin
        ce_out_reg <= 1'b0;
      end
      else begin
          ce_out_reg <= ce_gated;
      end
    end // ce_output_register

  //   ------------------ Input Register ------------------

  always @ (posedge clk or posedge reset)
    begin: input_reg_process
      if (reset == 1'b1) begin
        input_register <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          input_register <= filter_in;
        end
      end
    end // input_reg_process

  //   ------------------ Section # 1 : Integrator ------------------

  assign section_in1 = input_register;

  assign section_cast1 = $signed({{56{section_in1[15]}}, section_in1[15:11]});

  assign add_cast = section_cast1;
  assign add_cast_1 = section_out1;
  assign add_temp = add_cast + add_cast_1;
  assign sum1 = add_temp[60:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section1
      if (reset == 1'b1) begin
        section_out1 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out1 <= sum1;
        end
      end
    end // integrator_delay_section1

  //   ------------------ Section # 2 : Integrator ------------------

  assign section_in2 = section_out1;

  assign add_cast_2 = section_in2;
  assign add_cast_3 = section_out2;
  assign add_temp_1 = add_cast_2 + add_cast_3;
  assign sum2 = add_temp_1[60:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section2
      if (reset == 1'b1) begin
        section_out2 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out2 <= sum2;
        end
      end
    end // integrator_delay_section2

  //   ------------------ Section # 3 : Integrator ------------------

  assign section_in3 = section_out2;

  assign add_cast_4 = section_in3;
  assign add_cast_5 = section_out3;
  assign add_temp_2 = add_cast_4 + add_cast_5;
  assign sum3 = add_temp_2[60:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section3
      if (reset == 1'b1) begin
        section_out3 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out3 <= sum3;
        end
      end
    end // integrator_delay_section3

  //   ------------------ Section # 4 : Integrator ------------------

  assign section_in4 = section_out3;

  assign section_cast4 = section_in4[60:12];

  assign add_cast_6 = section_cast4;
  assign add_cast_7 = section_out4;
  assign add_temp_3 = add_cast_6 + add_cast_7;
  assign sum4 = add_temp_3[48:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section4
      if (reset == 1'b1) begin
        section_out4 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out4 <= sum4;
        end
      end
    end // integrator_delay_section4

  //   ------------------ Section # 5 : Integrator ------------------

  assign section_in5 = section_out4;

  assign section_cast5 = section_in5[48:7];

  assign add_cast_8 = section_cast5;
  assign add_cast_9 = section_out5;
  assign add_temp_4 = add_cast_8 + add_cast_9;
  assign sum5 = add_temp_4[41:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section5
      if (reset == 1'b1) begin
        section_out5 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out5 <= sum5;
        end
      end
    end // integrator_delay_section5

  //   ------------------ Section # 6 : Integrator ------------------

  assign section_in6 = section_out5;

  assign section_cast6 = section_in6[41:6];

  assign add_cast_10 = section_cast6;
  assign add_cast_11 = section_out6;
  assign add_temp_5 = add_cast_10 + add_cast_11;
  assign sum6 = add_temp_5[35:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section6
      if (reset == 1'b1) begin
        section_out6 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out6 <= sum6;
        end
      end
    end // integrator_delay_section6

  //   ------------------ Section # 7 : Integrator ------------------

  assign section_in7 = section_out6;

  assign section_cast7 = section_in7[35:7];

  assign add_cast_12 = section_cast7;
  assign add_cast_13 = section_out7;
  assign add_temp_6 = add_cast_12 + add_cast_13;
  assign sum7 = add_temp_6[28:0];

  always @ (posedge clk or posedge reset)
    begin: integrator_delay_section7
      if (reset == 1'b1) begin
        section_out7 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          section_out7 <= sum7;
        end
      end
    end // integrator_delay_section7

  //   ------------------ Section # 8 : Comb ------------------

  assign section_in8 = section_out7;

  assign section_cast8 = section_in8[28:3];

  assign sub_cast = section_cast8;
  assign sub_cast_1 = diff1;
  assign sub_temp = sub_cast - sub_cast_1;
  assign section_out8 = sub_temp[25:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section8
      if (reset == 1'b1) begin
        diff1 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff1 <= section_cast8;
        end
      end
    end // comb_delay_section8

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section8
      if (reset == 1'b1) begin
        cic_pipeline8 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline8 <= section_out8;
        end
      end
    end // cic_pipeline_process_section8

  //   ------------------ Section # 9 : Comb ------------------

  assign section_in9 = cic_pipeline8;

  assign section_cast9 = section_in9[25:1];

  assign sub_cast_2 = section_cast9;
  assign sub_cast_3 = diff2;
  assign sub_temp_1 = sub_cast_2 - sub_cast_3;
  assign section_out9 = sub_temp_1[24:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section9
      if (reset == 1'b1) begin
        diff2 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff2 <= section_cast9;
        end
      end
    end // comb_delay_section9

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section9
      if (reset == 1'b1) begin
        cic_pipeline9 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline9 <= section_out9;
        end
      end
    end // cic_pipeline_process_section9

  //   ------------------ Section # 10 : Comb ------------------

  assign section_in10 = cic_pipeline9;

  assign section_cast10 = section_in10[24:1];

  assign sub_cast_4 = section_cast10;
  assign sub_cast_5 = diff3;
  assign sub_temp_2 = sub_cast_4 - sub_cast_5;
  assign section_out10 = sub_temp_2[23:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section10
      if (reset == 1'b1) begin
        diff3 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff3 <= section_cast10;
        end
      end
    end // comb_delay_section10

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section10
      if (reset == 1'b1) begin
        cic_pipeline10 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline10 <= section_out10;
        end
      end
    end // cic_pipeline_process_section10

  //   ------------------ Section # 11 : Comb ------------------

  assign section_in11 = cic_pipeline10;

  assign section_cast11 = section_in11[23:1];

  assign sub_cast_6 = section_cast11;
  assign sub_cast_7 = diff4;
  assign sub_temp_3 = sub_cast_6 - sub_cast_7;
  assign section_out11 = sub_temp_3[22:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section11
      if (reset == 1'b1) begin
        diff4 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff4 <= section_cast11;
        end
      end
    end // comb_delay_section11

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section11
      if (reset == 1'b1) begin
        cic_pipeline11 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline11 <= section_out11;
        end
      end
    end // cic_pipeline_process_section11

  //   ------------------ Section # 12 : Comb ------------------

  assign section_in12 = cic_pipeline11;

  assign sub_cast_8 = section_in12;
  assign sub_cast_9 = diff5;
  assign sub_temp_4 = sub_cast_8 - sub_cast_9;
  assign section_out12 = sub_temp_4[22:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section12
      if (reset == 1'b1) begin
        diff5 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff5 <= section_in12;
        end
      end
    end // comb_delay_section12

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section12
      if (reset == 1'b1) begin
        cic_pipeline12 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline12 <= section_out12;
        end
      end
    end // cic_pipeline_process_section12

  //   ------------------ Section # 13 : Comb ------------------

  assign section_in13 = cic_pipeline12;

  assign section_cast13 = section_in13[22:1];

  assign sub_cast_10 = section_cast13;
  assign sub_cast_11 = diff6;
  assign sub_temp_5 = sub_cast_10 - sub_cast_11;
  assign section_out13 = sub_temp_5[21:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section13
      if (reset == 1'b1) begin
        diff6 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff6 <= section_cast13;
        end
      end
    end // comb_delay_section13

  always @ (posedge clk or posedge reset)
    begin: cic_pipeline_process_section13
      if (reset == 1'b1) begin
        cic_pipeline13 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          cic_pipeline13 <= section_out13;
        end
      end
    end // cic_pipeline_process_section13

  //   ------------------ Section # 14 : Comb ------------------

  assign section_in14 = cic_pipeline13;

  assign section_cast14 = section_in14[21:1];

  assign sub_cast_12 = section_cast14;
  assign sub_cast_13 = diff7;
  assign sub_temp_6 = sub_cast_12 - sub_cast_13;
  assign section_out14 = sub_temp_6[20:0];

  always @ (posedge clk or posedge reset)
    begin: comb_delay_section14
      if (reset == 1'b1) begin
        diff7 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          diff7 <= section_cast14;
        end
      end
    end // comb_delay_section14

  assign output_typeconvert = section_out14[20:3];

  //   ------------------ Output Register ------------------

  always @ (posedge clk or posedge reset)
    begin: output_reg_process
      if (reset == 1'b1) begin
        output_register <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          output_register <= output_typeconvert;
        end
      end
    end // output_reg_process

  // Assignment Statements
  assign ce_out = ce_out_reg;
  assign filter_out = output_register;
endmodule  // CIC_R256_M1_N7
